import { IWorkbenchContribution } from "@codingame/monaco-vscode-api/vscode/vs/workbench/common/contributions";
import { Disposable } from "@codingame/monaco-vscode-api/vscode/vs/base/common/lifecycle";
import { IEditorResolverService } from "@codingame/monaco-vscode-api/vscode/vs/workbench/services/editor/common/editorResolverService.service";
import { IExtensionService } from "@codingame/monaco-vscode-api/vscode/vs/workbench/services/extensions/common/extensions.service";
import { IWorkbenchEnvironmentService } from "@codingame/monaco-vscode-api/vscode/vs/workbench/services/environment/common/environmentService.service";
export declare class DynamicEditorConfigurations extends Disposable implements IWorkbenchContribution {
    private readonly editorResolverService;
    private readonly environmentService;
    static readonly ID = "workbench.contrib.dynamicEditorConfigurations";
    private static readonly AUTO_LOCK_DEFAULT_ENABLED;
    private static readonly AUTO_LOCK_EXTRA_EDITORS;
    private static readonly AUTO_LOCK_REMOVE_EDITORS;
    private readonly configurationRegistry;
    private autoLockConfigurationNode;
    private defaultBinaryEditorConfigurationNode;
    private editorAssociationsConfigurationNode;
    private editorLargeFileConfirmationConfigurationNode;
    constructor(editorResolverService: IEditorResolverService, extensionService: IExtensionService, environmentService: IWorkbenchEnvironmentService);
    private registerListeners;
    private updateDynamicEditorConfigurations;
}
