import { IView } from "@codingame/monaco-vscode-6980eeab-47bb-5a48-8e15-32caf0785565-common/vscode/vs/base/browser/ui/grid/grid";
import { Disposable, IDisposable } from "@codingame/monaco-vscode-api/vscode/vs/base/common/lifecycle";
import { IObservable } from "@codingame/monaco-vscode-api/vscode/vs/base/common/observable";
import { IEditorContributionDescription } from "@codingame/monaco-vscode-api/vscode/vs/editor/browser/editorExtensions";
import { CodeEditorWidget } from "@codingame/monaco-vscode-api/vscode/vs/editor/browser/widget/codeEditor/codeEditorWidget";
import { IEditorOptions } from "@codingame/monaco-vscode-api/vscode/vs/editor/common/config/editorOptions";
import { Range } from "@codingame/monaco-vscode-api/vscode/vs/editor/common/core/range";
import { Selection } from "@codingame/monaco-vscode-api/vscode/vs/editor/common/core/selection";
import { MenuId } from "@codingame/monaco-vscode-api/vscode/vs/platform/actions/common/actions";
import { IConfigurationService } from "@codingame/monaco-vscode-api/vscode/vs/platform/configuration/common/configuration.service";
import { IInstantiationService } from "@codingame/monaco-vscode-api/vscode/vs/platform/instantiation/common/instantiation";
import { MergeEditorViewModel } from "../viewModel.js";
export declare abstract class CodeEditorView extends Disposable {
    private readonly instantiationService;
    readonly viewModel: IObservable<undefined | MergeEditorViewModel>;
    private readonly configurationService;
    readonly model: IObservable<import("@codingame/monaco-vscode-8ccb7637-50ea-5359-97bf-00015d7fe567-common/vscode/vs/workbench/contrib/mergeEditor/browser/model/mergeEditorModel").MergeEditorModel | undefined>;
    protected readonly htmlElements: {
        description: HTMLSpanElement;
        root: HTMLSpanElement & HTMLDivElement;
        title: HTMLSpanElement;
        detail: HTMLSpanElement;
        toolbar: HTMLSpanElement;
        header: HTMLDivElement;
        editor: HTMLDivElement;
        gutterDiv: HTMLDivElement;
    };
    private readonly _onDidViewChange;
    readonly view: IView;
    protected readonly checkboxesVisible: IObservable<boolean>;
    protected readonly showDeletionMarkers: IObservable<boolean>;
    protected readonly useSimplifiedDecorations: IObservable<boolean>;
    readonly editor: CodeEditorWidget;
    updateOptions(newOptions: Readonly<IEditorOptions>): void;
    readonly isFocused: IObservable<boolean>;
    readonly cursorPosition: IObservable<import("@codingame/monaco-vscode-api/vscode/vs/editor/common/core/position").Position | null>;
    readonly selection: IObservable<Selection[] | null>;
    readonly cursorLineNumber: IObservable<number | undefined>;
    constructor(instantiationService: IInstantiationService, viewModel: IObservable<undefined | MergeEditorViewModel>, configurationService: IConfigurationService);
    protected getEditorContributions(): IEditorContributionDescription[];
}
export declare function createSelectionsAutorun(codeEditorView: CodeEditorView, translateRange: (baseRange: Range, viewModel: MergeEditorViewModel) => Range): IDisposable;
export declare class TitleMenu extends Disposable {
    constructor(menuId: MenuId, targetHtmlElement: HTMLElement, instantiationService: IInstantiationService);
}
