import { IAction } from "@codingame/monaco-vscode-api/vscode/vs/base/common/actions";
import { Disposable } from "@codingame/monaco-vscode-api/vscode/vs/base/common/lifecycle";
import { IObservable, ITransaction } from "@codingame/monaco-vscode-api/vscode/vs/base/common/observable";
import { IConfigurationService } from "@codingame/monaco-vscode-api/vscode/vs/platform/configuration/common/configuration.service";
import { IContextMenuService } from "@codingame/monaco-vscode-api/vscode/vs/platform/contextview/browser/contextView.service";
import { IInstantiationService } from "@codingame/monaco-vscode-api/vscode/vs/platform/instantiation/common/instantiation";
import { InputState, ModifiedBaseRange } from "@codingame/monaco-vscode-210e86a9-a91b-5273-b05d-390c776dde1f-common/vscode/vs/workbench/contrib/mergeEditor/browser/model/modifiedBaseRange";
import { MergeEditorViewModel } from "../viewModel.js";
import { IGutterItemInfo, IGutterItemView } from "../editorGutter.js";
import { CodeEditorView } from "./codeEditorView.js";
export declare class InputCodeEditorView extends CodeEditorView {
    readonly inputNumber: 1 | 2;
    readonly otherInputNumber: number;
    constructor(inputNumber: 1 | 2, viewModel: IObservable<MergeEditorViewModel | undefined>, instantiationService: IInstantiationService, contextMenuService: IContextMenuService, configurationService: IConfigurationService);
    private readonly modifiedBaseRangeGutterItemInfos;
    private readonly decorations;
}
export declare class ModifiedBaseRangeGutterItemModel implements IGutterItemInfo {
    readonly id: string;
    private readonly baseRange;
    private readonly inputNumber;
    private readonly viewModel;
    private readonly model;
    readonly range: import("@codingame/monaco-vscode-210e86a9-a91b-5273-b05d-390c776dde1f-common/vscode/vs/workbench/contrib/mergeEditor/browser/model/lineRange").LineRange;
    constructor(id: string, baseRange: ModifiedBaseRange, inputNumber: 1 | 2, viewModel: MergeEditorViewModel);
    readonly enabled: IObservable<boolean>;
    readonly toggleState: IObservable<InputState>;
    readonly state: IObservable<{
        handled: boolean;
        focused: boolean;
    }>;
    setState(value: boolean, tx: ITransaction): void;
    toggleBothSides(): void;
    getContextMenuActions(): readonly IAction[];
}
export declare class MergeConflictGutterItemView extends Disposable implements IGutterItemView<ModifiedBaseRangeGutterItemModel> {
    private readonly item;
    private readonly checkboxDiv;
    private readonly isMultiLine;
    constructor(item: ModifiedBaseRangeGutterItemModel, target: HTMLElement, contextMenuService: IContextMenuService);
    layout(top: number, height: number, viewTop: number, viewHeight: number): void;
    update(baseRange: ModifiedBaseRangeGutterItemModel): void;
}
