import { Dimension } from "@codingame/monaco-vscode-api/vscode/vs/base/browser/dom";
import { IMouseWheelEvent } from "@codingame/monaco-vscode-api/vscode/vs/base/browser/mouseEvent";
import { CodeWindow } from "@codingame/monaco-vscode-api/vscode/vs/base/browser/window";
import { Disposable } from "@codingame/monaco-vscode-api/vscode/vs/base/common/lifecycle";
import { URI } from "@codingame/monaco-vscode-api/vscode/vs/base/common/uri";
import { IContextKeyService } from "@codingame/monaco-vscode-api/vscode/vs/platform/contextkey/common/contextkey.service";
import { ExtensionIdentifier } from "@codingame/monaco-vscode-api/vscode/vs/platform/extensions/common/extensions";
import { IWorkbenchLayoutService } from "@codingame/monaco-vscode-api/vscode/vs/workbench/services/layout/browser/layoutService.service";
import { IOverlayWebview, WebviewContentOptions, WebviewExtensionDescription, WebviewInitInfo, WebviewMessageReceivedEvent, WebviewOptions } from "@codingame/monaco-vscode-7ba0af96-90c2-5e11-ad7f-befdbbf246c8-common/vscode/vs/workbench/contrib/webview/browser/webview";
import { IWebviewService } from "@codingame/monaco-vscode-api/vscode/vs/workbench/contrib/webview/browser/webview.service";
export declare class OverlayWebview extends Disposable implements IOverlayWebview {
    private readonly _layoutService;
    private readonly _webviewService;
    private readonly _baseContextKeyService;
    private _isFirstLoad;
    private readonly _firstLoadPendingMessages;
    private readonly _webview;
    private readonly _webviewEvents;
    private _html;
    private _title;
    private _initialScrollProgress;
    private _state;
    private _extension;
    private _contentOptions;
    private _options;
    private _owner;
    private _windowId;
    private get window();
    private readonly _scopedContextKeyService;
    private _findWidgetVisible;
    private _findWidgetEnabled;
    private _shouldShowFindWidgetOnRestore;
    readonly providedViewType?: string;
    origin: string;
    private _container;
    constructor(initInfo: WebviewInitInfo, _layoutService: IWorkbenchLayoutService, _webviewService: IWebviewService, _baseContextKeyService: IContextKeyService);
    get isFocused(): boolean;
    private _isDisposed;
    private readonly _onDidDispose;
    readonly onDidDispose: import("@codingame/monaco-vscode-api/vscode/vs/base/common/event").Event<void>;
    dispose(): void;
    get container(): HTMLElement;
    claim(owner: any, targetWindow: CodeWindow, scopedContextKeyService: IContextKeyService | undefined): void;
    release(owner: any): void;
    layoutWebviewOverElement(element: HTMLElement, dimension?: Dimension, clippingContainer?: HTMLElement): void;
    private doLayoutWebviewOverElement;
    private _show;
    setHtml(html: string): void;
    setTitle(title: string): void;
    get initialScrollProgress(): number;
    set initialScrollProgress(value: number);
    get state(): string | undefined;
    set state(value: string | undefined);
    get extension(): WebviewExtensionDescription | undefined;
    set extension(value: WebviewExtensionDescription | undefined);
    get options(): WebviewOptions;
    set options(value: WebviewOptions);
    get contentOptions(): WebviewContentOptions;
    set contentOptions(value: WebviewContentOptions);
    set localResourcesRoot(resources: URI[]);
    private readonly _onDidFocus;
    readonly onDidFocus: import("@codingame/monaco-vscode-api/vscode/vs/base/common/event").Event<void>;
    private readonly _onDidBlur;
    readonly onDidBlur: import("@codingame/monaco-vscode-api/vscode/vs/base/common/event").Event<void>;
    private readonly _onDidClickLink;
    readonly onDidClickLink: import("@codingame/monaco-vscode-api/vscode/vs/base/common/event").Event<string>;
    private readonly _onDidReload;
    readonly onDidReload: import("@codingame/monaco-vscode-api/vscode/vs/base/common/event").Event<void>;
    private readonly _onDidScroll;
    readonly onDidScroll: import("@codingame/monaco-vscode-api/vscode/vs/base/common/event").Event<{
        readonly scrollYPercentage: number;
    }>;
    private readonly _onDidUpdateState;
    readonly onDidUpdateState: import("@codingame/monaco-vscode-api/vscode/vs/base/common/event").Event<string | undefined>;
    private readonly _onMessage;
    readonly onMessage: import("@codingame/monaco-vscode-api/vscode/vs/base/common/event").Event<WebviewMessageReceivedEvent>;
    private readonly _onMissingCsp;
    readonly onMissingCsp: import("@codingame/monaco-vscode-api/vscode/vs/base/common/event").Event<ExtensionIdentifier>;
    private readonly _onDidWheel;
    readonly onDidWheel: import("@codingame/monaco-vscode-api/vscode/vs/base/common/event").Event<IMouseWheelEvent>;
    private readonly _onFatalError;
    onFatalError: import("@codingame/monaco-vscode-api/vscode/vs/base/common/event").Event<{
        readonly message: string;
    }>;
    postMessage(message: any, transfer?: readonly ArrayBuffer[]): Promise<boolean>;
    focus(): void;
    reload(): void;
    selectAll(): void;
    copy(): void;
    paste(): void;
    cut(): void;
    undo(): void;
    redo(): void;
    showFind(animated?: boolean): void;
    hideFind(animated?: boolean): void;
    runFindAction(previous: boolean): void;
    private _withWebview;
    windowDidDragStart(): void;
    windowDidDragEnd(): void;
    setContextKeyService(contextKeyService: IContextKeyService): void;
}
