import { Disposable } from "@codingame/monaco-vscode-api/vscode/vs/base/common/lifecycle";
import { IInstantiationService } from "@codingame/monaco-vscode-api/vscode/vs/platform/instantiation/common/instantiation";
import { WebviewThemeDataProvider } from "./themeing.js";
import { IOverlayWebview, IWebview, IWebviewElement, WebviewInitInfo } from "@codingame/monaco-vscode-7ba0af96-90c2-5e11-ad7f-befdbbf246c8-common/vscode/vs/workbench/contrib/webview/browser/webview";
import { IWebviewService } from "@codingame/monaco-vscode-api/vscode/vs/workbench/contrib/webview/browser/webview.service";
export declare class WebviewService extends Disposable implements IWebviewService {
    protected readonly _instantiationService: IInstantiationService;
    readonly _serviceBrand: undefined;
    protected readonly _webviewThemeDataProvider: WebviewThemeDataProvider;
    constructor(_instantiationService: IInstantiationService);
    private _activeWebview?;
    get activeWebview(): IWebview | undefined;
    private _updateActiveWebview;
    private _webviews;
    get webviews(): Iterable<IWebview>;
    private readonly _onDidChangeActiveWebview;
    readonly onDidChangeActiveWebview: import("@codingame/monaco-vscode-api/vscode/vs/base/common/event").Event<IWebview | undefined>;
    createWebviewElement(initInfo: WebviewInitInfo): IWebviewElement;
    createWebviewOverlay(initInfo: WebviewInitInfo): IOverlayWebview;
    protected registerNewWebview(webview: IWebview): void;
}
